
#if !defined (MPI_TEST_H)
#define MPI_TEST_H


/***************************************************************************
  include section
***************************************************************************/

#include <stdio.h>        /* Standard Input/Output Library     */
#include <stdlib.h>       /* Standard Utilities Library        */

#include "mpi.h"          /* Message Passing Interface Library */

#include "env.h"
/***************************************************************************
  definitions section
***************************************************************************/

#define KILOBYTE 1024
#define MEGABYTE 1048576

#ifdef _USE_MPI_WTIME
#define Wtime MPI_Wtime
#endif

/* comment out this define to return 
  to old transfer rates as they are by Rif */

#define TRANSFER_RATE_LINK_AVG

#define iTIMES 500
                              /*
				 A    number    of    send-receive
				 operations are  used iTIMES times
				 for obtain the average result.
			      */

#define iSTART 1024
#define iSTART_SIZE KILOBYTE
#define iMAX_SIZE 256*KILOBYTE

#define iROOT  0
				/* root process */

#define iTAG 1000
				/* A tag of send message */

#define iSEND_TAG 1000
				/* A tag of send message */

#define iRECV_TAG 2000
				/* A tag of receive message */


/***************************************************************************
  prototype section.
***************************************************************************/

void main ( int iArgumentCount, char *sArguments [ ] );
void SetSize ( int iArgumentCount, char *sArguments [ ], int *isize );
void finish(char*);

double Chaos  (int iSIZE,int TIMES); /* Chaos topology (blocking) test.     */
double iChaos (int iSIZE,int TIMES); /* Chaos topology (non-blocking) test. */
double Star   (int iSIZE,int TIMES); /* Star topology (blocking) test.      */
double iStar  (int iSIZE,int TIMES); /* Star topology (non-blocking) test.  */
double Ring   (int iSIZE,int TIMES); /* Ring topology (blocking) test.      */
double Ring1  (int iSIZE,int TIMES); /* Ring topology (sendrecv) test.      */
double Ring2  (int iSIZE,int TIMES); /* Ring topology (non-blocking) test.  */

#endif /* MPI_TEST_H */

/* End of file 'mpi-test.h' */
